<template>
  <div style="width: 100%;">
    <a-card :bordered="false">
      <!-- 查询区域 -->
      <div class="table-page-search-wrapper">
        <a-form layout="inline" @keyup.enter.native="searchQuery">
          <a-row :gutter="24">
            <a-col :md="6" :sm="6">
              <a-form-item label="时间">
                <a-range-picker @change="dateParamChange" :disabledDate="disabledDate" format="YYYYMMDD" v-model="dates"/>
              </a-form-item>
            </a-col>
            <a-col :lg="3" :md="3" :sm="3" :xs="3">
              <a-button type="primary" @click="searchQuery" icon="search">查询</a-button>
            </a-col>
            <a-col :lg="3"  :md="3" :sm="3" :xs="3">
              <a-button type="primary" @click="searchReset" icon="reload">重置</a-button>
            </a-col>
            <a-col :lg="3" :md="3" :sm="3" :xs="3">
              <a-button type="primary" @click="exportExcel" icon="download">导出</a-button>
            </a-col>
          </a-row>
          <a-row :gutter="24">
            <a-col :md="15" :sm="15">
              <a-checkbox-group :value="checkedList" :default-value="['lyl']" :options="efficiencyOptions"
                                @change="efficiencyOptionsOnChange"/>
            </a-col>
          </a-row>
        </a-form>
      </div>
      <div style="width: 530px;position: absolute;top: 20px; right:1.5%;">
        <table cellpadding="5" cellspacing="1" style="border: 1px solid darkgray;">
          <tr>
            <td v-for="(item, index) in identifying">{{item.title}}</td>
          </tr>
          <tr>
            <td style="text-align:center;" v-for="(item, index) in identifying">
              <div class="identifyingclass" :style="{background: item.color}"></div>
            </td>
            <!--<td style="text-align:center;"><div style="width: 55px;height: 15px;background-color: #e8ff37;display:inline-block"></div></td>-->
            <!--<td style="text-align:center;"><div style="width: 55px;height: 15px;background-color: #99ff4e;display:inline-block"></div></td>-->
          </tr>
        </table>
      </div>
      <div class="container" id="EfficiencyPO" style="margin-top: 20px;">
        <div class="table2">
          <table class="dataContent table" border="1" cellspacing="0" cellpadding="0" style="white-space: nowrap">
            <thead>
            <tr class="thead fixed equipname">
              <th class="thgu dong1 name" rowspan="2" style="min-width: 150px; max-width: 150px;width: 150px;"></th>
              <th  class="thgu dong2 name" rowspan="2" style="min-width: 150px; max-width: 150px;width: 150px;"></th>
              <th  class="thgu dong3 name" rowspan="2" style="min-width: 150px; max-width: 150px;width: 150px;"></th>
              <th class="thgu dong4 name" rowspan="2" style="min-width: 100px; max-width: 100px;width: 100px;">设备编号</th>
              <th class="thgu dong5 name" rowspan="2" style="min-width: 150px; max-width: 150px;width: 150px;">设备名称</th>
              <th class="thgu dong6 name" rowspan="2" style="min-width: 100px; max-width: 100px;width: 100px;">设备类型</th>
              <!--<th rowspan="2">组别</th>-->
              <template v-for="(tableHead, index) in tableHeads">
                <th class="timeth" :colspan="checkedList.length">{{tableHead}}</th>
              </template>
            </tr>
            <tr class="thead notfixed gudingth">
              <template v-for="(tableHead, index) in tableHeads">
                <th>开动率(%)</th>
                <th v-if="checkedList.indexOf('kjl') > -1">开机率(%)</th>
                <th v-if="checkedList.indexOf('kjsj') > -1">开机时间(s)</th>
                <th v-if="checkedList.indexOf('jgsj') > -1">加工时间(s)</th>
                <th v-if="checkedList.indexOf('djsj') > -1">待机时间(s)</th>
                <th v-if="checkedList.indexOf('gjsj') > -1">关机时间(s)</th>
              </template>
            </tr>
            </thead>
            <tbody>
            <tr class="mathData" v-for="(item, index) in dataList">
              <td  class="tdgu kaitou" :rowspan="item.level1span" :class="{hidden: item.level1dis,noExl:item.level1dis}"  v-show="!item.level1dis">{{item.level1}}</td>
              <td  class="tdgu1 kaitou" :rowspan="item.level2span" :class="{hidden: item.level2dis,noExl:item.level2dis}"  v-show="!item.level2dis">{{item.level2}}</td>
              <td  class="tdgu2 kaitou" :rowspan="item.level3span" :class="{hidden: item.level3dis,noExl:item.level3dis}"  v-show="!item.level3dis">{{item.level3}}</td>
              <td  class="tdgu3  kaitou">{{item.equipmentId}}</td>
              <td  class="tdgu4 kaitou">{{item.equipmentName}}</td>
              <td  class="tdgu5 kaitou">{{item.equipmentType}}</td>
              <!--<td>{{item.tierType}}</td>-->
              <template v-for="(tableHead, index) in item.dataList">
                <td :style="{background:tableHead.color }">{{tableHead.startRate | numFilter}}</td>
                <td :style="{background:tableHead.color }" v-if="checkedList.indexOf('kjl') > -1">
                  {{tableHead.openRate | numFilter}}
                </td>
                <td :style="{background:tableHead.color }" v-if="checkedList.indexOf('kjsj') > -1">
                  {{tableHead.openLong}}
                </td>
                <td :style="{background:tableHead.color }" v-if="checkedList.indexOf('jgsj') > -1">
                  {{tableHead.processLong}}
                </td>
                <td :style="{background:tableHead.color }" v-if="checkedList.indexOf('djsj') > -1">
                  {{tableHead.waitLong}}
                </td>
                <td :style="{background:tableHead.color }" v-if="checkedList.indexOf('gjsj') > -1">
                  {{tableHead.closeLong}}
                </td>
              </template>
            </tr>
            </tbody>
          </table>
        </div>
      </div>
    </a-card>
  </div>
</template>

<script>
import moment from 'moment'
import { putAction, getAction } from '@/api/manage'
import $ from 'jquery'
import '@/components/table2excel/table2excel'
import { ajaxGetDictItems, getDictItemsFromCache, duplicateCheck } from '@/api/api'
export default {
  name: 'EfficiencyPOList',
  components: {},
  data() {
    return {
      typeTree:"",
      typeParent:1,
      typeEquipment:1,
      dates: [],
      queryParam: {},
      queryParamEquip:{},
      queryParamPeople:{},
      identifying: [],
      efficiencyOptions: [
        { label: '开动率', value: 'lyl' },
        { label: '开机率', value: 'kjl' },
        { label: '开机时间', value: 'kjsj' },
        { label: '加工时间', value: 'jgsj' },
        { label: '待机时间', value: 'djsj' },
        { label: '关机时间', value: 'gjsj' }
      ],
      checkedList: ['lyl'],
      dataList: [],
      url: {
        list: '/mdc/efficiencyReport/efficiencyPOList',
        listByType: '/mdc/MdcUtilizationRate/getByType'
      },
      tableHeads: []
    }
  },
  props: { nodeTree: '', Type:'',nodePeople: ''},
  created() {
    this.showIdentifying()
    this.dates = [moment().subtract('days', 8), moment().subtract('days', 1)]
    this.queryParam.startTime = moment(this.dates[0]).format('YYYYMMDD')
    this.queryParam.endTime = moment(this.dates[1]).format('YYYYMMDD')
    this.queryParam.typeTree = "1"
    this.loadData()
  },
  watch: {
    Type(valmath){
      this.dataList = [];
      this.queryParam.typeTree = valmath
    },
    nodeTree(val) { //监听currSelected 变化，将变化后的数值传递给 getCurrSelected 事件
      if (JSON.stringify(val) != '{}') {
        if (val.equipmentId != null) {
          this.queryParamEquip.parentId = ''
          this.queryParamEquip.equipmentId = val.equipmentId
        } else {
          this.queryParamEquip.parentId = val.key
          this.queryParamEquip.equipmentId = ''
        }
        this.searchQuery()
      }
    },
    nodePeople(val){
      if (JSON.stringify(val) != '{}') {
        if (val.equipmentId != null) {
          this.queryParamPeople.parentId = val.equipmentId
          this.queryParamPeople.equipmentId = ''
        } else {
          this.queryParamPeople.parentId = val.key
          this.queryParamPeople.equipmentId = ''
        }
        this.searchQuery()
      }
    }
  },
  filters: {
    numFilter(value) {
      if (value) {
        return parseFloat((value * 100).toFixed(2))
      } else {
        return '0'
      }
    }
  },
  methods: {
    checkSameData(dataList){
      let cache = {};  //存储的是键是kclx 的值，值是kclx 在indeces中数组的下标
      let indices = [];  //数组中每一个值是一个数组，数组中的每一个元素是原数组中相同kclx的下标
      dataList.map((item,index)=>{
        let level1 = item.level1;
        let _index = cache[level1];
        if(_index!==undefined){
          indices[_index].push(index)
        }else{
          cache[level1] = indices.length
          indices.push([index])
        }
      })
      let result = [];
      indices.map((item)=>{
        item.map((index)=>{
          result.push(dataList[index])
        })
      })
      this.dataList = result
    },
    checkSameData1(dataList){
      let cache = {};  //存储的是键是kclx 的值，值是kclx 在indeces中数组的下标
      let indices = [];  //数组中每一个值是一个数组，数组中的每一个元素是原数组中相同kclx的下标
      dataList.map((item,index)=>{
        let level2 = item.level2;
        let _index = cache[level2];
        if(_index!==undefined){
          indices[_index].push(index)
        }else{
          cache[level2] = indices.length
          indices.push([index])
        }
      })
      let result = [];
      indices.map((item)=>{
        item.map((index)=>{
          result.push(dataList[index])
        })
      })
      this.dataList = result
    },
    checkSameData2(dataList){
      let cache = {};  //存储的是键是kclx 的值，值是kclx 在indeces中数组的下标
      let indices = [];  //数组中每一个值是一个数组，数组中的每一个元素是原数组中相同kclx的下标
      dataList.map((item,index)=>{
        let level3 = item.level3;
        let _index = cache[level3];
        if(_index!==undefined){
          indices[_index].push(index)
        }else{
          cache[level3] = indices.length
          indices.push([index])
        }
      })
      let result = [];
      indices.map((item)=>{
        item.map((index)=>{
          result.push(dataList[index])
        })
      })
      this.dataList = result
    },
    // 合并
    combineCell() {
      console.log(this.dataList)
      let list =this.dataList;
      for (let field in list[0]) {
        var k = 0;
        while (k < list.length) {
          list[k][field + 'span'] = 1;
          list[k][field + 'dis'] = false;
          for (var i = k + 1; i <= list.length - 1; i++) {
            if (list[k][field] == list[i][field] && list[k][field] != '') {
              list[k][field + 'span']++;
              list[k][field + 'dis'] = false;
              list[i][field + 'span'] = 1;
              list[i][field + 'dis'] = true;
            } else {
              break;
            }
          }
          k = i;
        }
      }
      return list;
    },
    disabledDate(current){
      //Can not slect days before today and today
      return current && current > moment().subtract('days', 1);
    },
    initDeviceType(deviceList) {
      let dictCode = 'mdc_equipmentType'
      let items = []
      items = getDictItemsFromCache(dictCode)
      console.log(items)
      if (deviceList && items.length > 0) {
        for (let a = 0; a < deviceList.length; a++) {
          if (items && items.length > 0) {
            for (let i = 0; i < items.length; i++) {
              if (deviceList[a].equipmentType == items[i].value) {
                deviceList[a].equipmentType = items[i].title
              }
            }
          } else {
            ajaxGetDictItems(dictCode, null).then((res) => {
              if (res.success) {
                let items = res.result
                for (let i = 0; i < items.length; i++) {
                  if (deviceList[a].equipmentType == items[i].value) {
                    deviceList[a].equipmentType = items[i].title
                  }
                }
              }
            })
          }
        }
      }
    },
    exportExcel() {
      $("#EfficiencyPO").table2excel({
        exclude: ".noExl",
        name: "Excel Document Name",
        filename: "设备开动率",
        exclude_img: true,
        fileext: ".xls",
        exclude_links: true,
        exclude_inputs: true
      });
    },
    showIdentifying() {
      getAction(this.url.listByType, { type: 'kdl' }).then(res => {
        if (res.success) {
          this.identifying = res.result
        }
      })
    },
    dateParamChange(v1, v2) {
      this.queryParam.startTime = v2[0]
      this.queryParam.endTime = v2[1]
    },
    efficiencyOptionsOnChange(checkedList) {
      let index = checkedList.indexOf('lyl')
      if (index < 0) {
        this.$message.warn('不能取消查询利用率')
        return false
      }
      this.checkedList = checkedList
    },
    searchQuery() {
      if(this.queryParam.typeTree == "1"){
        this.queryParam.parentId =  this.queryParamEquip.parentId
        this.queryParam.equipmentId = this.queryParamEquip.equipmentId
      }else{
        this.queryParam.parentId = this.queryParamPeople.parentId
        this.queryParam.equipmentId = ""
      }
      this.loadData()
      // this.onClearSelected()
    },
    searchReset() {
      this.typeTree = this.queryParam.typeTree
      this.typeParent =  this.queryParam.parentId
      this.typeEquipment = this.queryParam.equipmentId
      this.queryParam = {}
      this.dates = []
      this.queryParam.typeTree = this.typeTree
      this.queryParam.parentId = this.typeParent
      this.queryParam.equipmentId =  this.typeEquipment
      // this.ipagination.current = 1
      this.loadData();
      // this.queryParam = {}
      // this.dates = []
      // this.loadData()
      // this.onClearSelected()
    },
    loadData() {
      this.tableHeads = []
      this.dataList = []
      getAction(this.url.list, this.queryParam).then(res => {
        if (res.success) {
          // console.log(res.result)
          this.tableHeads = res.result.dates
          this.dataList = res.result.mdcEfficiencyList
          this.checkSameData(this.dataList)
          this.checkSameData1(this.dataList)
          this.checkSameData2(this.dataList)
          this.combineCell();
          // this.initDeviceType(this.dataList)
        }
      })
    }
  }
}
</script>
<style scoped>
/*table样式*/
.table2{
  width: 100%;
  height: 100%;
  overflow: auto;
}
.table2 thead tr th:first-child,
.table tbody tr .tdgu{
  position: sticky;
  left: 0;
  z-index: 1;
}
.table tbody tr .kaitou{
  z-index: 1;
  background-color: white;
}
.table tbody tr .tdgu1{
  position: sticky;
  left: 150px;
  z-index: 2;
}
.table tbody tr .tdgu2{
  position: sticky;
  left: 300px;
  z-index: 2;
}
.table tbody tr .tdgu3{
  position: sticky;
  left: 450px;
  z-index: 2;
}
.table tbody tr .tdgu4{
  position: sticky;
  left: 550px;
  z-index: 2;
}
.table tbody tr .tdgu5{
  position: sticky;
  left: 700px;
  z-index: 2;
}

.table2 thead tr .timeth,
.table2 thead tr  .thgu {
  position: sticky;
  top:0;
  z-index: 3;
}
.table2 thead .gudingth th{
  position: sticky;
  top: 32px;
  z-index: 2;
}
.table2 thead .equipname .name{
  z-index: 3;
}
.table2 thead .equipname .dong1{
  z-index: 4;
  left: 0;
  /*border: 1px solid #000;*/
}
.table2 thead .equipname .dong2{
  z-index: 5;
  left: 150px;
}
.table2 thead .equipname .dong3{
  z-index: 5;
  left: 300px;
}
.table2 thead .equipname .dong4{
  z-index: 5;
  left: 450px;
}
.table2 thead .equipname .dong5{
  z-index: 5;
  left: 550px;
}
.table2 thead .equipname .dong6{
  z-index: 5;
  left: 700px;
}



@media screen and (min-width: 1920px){
  #EfficiencyPO{
    height: 687px!important;
    overflow: scroll;
  }
}
@media screen and (min-width: 1680px) and (max-width: 1920px){
  #EfficiencyPO{
    height: 687px!important;
    overflow: scroll;
  }
}
@media screen and (min-width: 1400px) and (max-width: 1680px){
  #EfficiencyPO{
    height: 540px!important;
    overflow: scroll;
  }
}
@media screen and (min-width: 1280px) and (max-width: 1400px){
  #EfficiencyPO{
    height: 440px!important;
    overflow: scroll;
  }
}
@media screen and (max-width: 1280px){
  #EfficiencyPO{
    height: 440px!important;
    overflow: scroll;
  }
}
.identifyingclass {
  width: 55px;
  height: 15px;
  display: inline-block
}
.dataContent {
  white-space: nowrap;
  /*margin: 0;*/
  border: none;
  border-collapse: separate;
  border-spacing: 0;
  /*table-layout: fixed;*/
  border: 1px solid #ccc;
  /*border: 1px solid #ccc;*/
  width: 100%;
  /*height: 100%;*/
  /*overflow: hidden;*/
  /*overflow-y: auto;*/
  text-align: center;
}

.dataContent .fixed th {
  width: 50px;
}

.dataContent .thead th {
  background-color: #fafafa;
  text-align: center;
  height: 30px;
  padding: 5px;
}

.dataContent .notfixed th {
  width: auto;
}

.dataContent tr td {
  height: 35px;
}

.dataContent .mathData td {
  padding: 10px;
  /*display: none;*/
}

.dataContent .mathData .td {
  /*background-color: #ff9bd2;*/
  display: inline-block;
  padding: 10px;
}

.dataContent .mathData .tdd {
  /*display: none;*/
}

</style>